﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;

namespace api_core_v2.Controllers
{
    [Route("")]
    [ApiController]
    public class ValuesController : ControllerBase
    {
        private readonly IpRangeContext db;
        private readonly SortedList<long, IpRangeItem> sortedList;

        public ValuesController(IpRangeContext db, SortedList<long, IpRangeItem> sortedList)
        {
            this.db = db;
            this.sortedList = sortedList;
        }

        // GET api/values
        [HttpGet]
        public ActionResult<object> Get()
        {
            return sortedList.Count();
            // return db.IpRanges.ToList();
        }

        // GET api/values/5
        [HttpGet("{ip}")]
        public ActionResult<IpRangeItem> Get(string ip)
        {
            long iplong = IpToLong(ip);

            // var q = from s in db.IpRanges
            //         where s.RangeMin <= iplong && s.RangeMax <= iplong
            //         select s;
            // var result = q.FirstOrDefault();

            var result = sortedList.Where(x => x.Key >= iplong).FirstOrDefault().Value;

            return result;
        }

        private static long IpToLong(string ip)
        {
            return (long)(uint)IPAddress.NetworkToHostOrder((int)IPAddress.Parse(ip).Address);
        }

        // POST api/values
        [HttpPost]
        public void Post([FromBody] string value)
        {
        }

        // PUT api/values/5
        [HttpPut("{id}")]
        public void Put(int id, [FromBody] string value)
        {
        }

        // DELETE api/values/5
        [HttpDelete("{id}")]
        public void Delete(int id)
        {
        }
    }
}
