﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using StackExchange.Redis;

namespace api_core.Controllers
{
    [Route("")]
    [ApiController]
    public class ValuesController : ControllerBase
    {
        private ConnectionMultiplexer _redis;

        private object asyncState;
        private IDatabase _db;

        public ValuesController(ConnectionMultiplexer redis)
        {
            // this._redis = redis;
            this._db = redis.GetDatabase(0, this.asyncState);
        }

        [HttpGet("/foo")]
        public async Task<string> GetAsync()
        {
            return "bar";
            // string value = "abcdefg";
            // await _db.StringSetAsync("foo", value);

            string result = await _db.StringGetAsync("foo");
            return result;
        }        

        // GET api/values/5
        [HttpGet("{ip}")]
        public async Task<object> Get(string ip)
        {
            var iplong = (long) (uint) IPAddress.NetworkToHostOrder((int) IPAddress.Parse(ip).Address);

            var code = await _db.SortedSetRangeByScoreAsync(
                key: "iprange:locations",
                start: iplong, skip: 0, take: 1
            );
            
            return code;
            // return await Task.FromResult(ip);
        }
    }
}
