#!/bin/env python
import json
import os

import redis
from flask import Flask, jsonify

import ip_helpers
import redis_helpers

REDIS_HOST = os.environ.get('REDIS_HOST', 'localhost')
REDIS_PORT = os.environ.get('REDIS_PORT', 6379)
REDIS_INDEX = os.environ.get('REDIS_INDEX', 'iprange:locations')

app = Flask(__name__)


@app.route('/<ip>')
def get_location(ip):
    client = redis.Redis(host=REDIS_HOST, port=REDIS_PORT, db=0)
    result = redis_helpers.get(ip, client, REDIS_INDEX)
    return jsonify(result)


if __name__ == '__main__':
    app.run(host='0.0.0.0', port=8000)
