#!/bin/env python
import json
import os

import redis

import ip_helpers


def get(ip, redisConn, index):
    """
    Get a range and all its data by ip
    """
    
    ipnum = ip_helpers.ip2long(ip)

    #get the location record from redis
    record = redisConn.zrangebyscore(index, ipnum ,'+inf', 0, 1, True)
    if not record:
        #not found? k!
        return None

    # return True # TODO

    try:
        data = json.loads(record[0][0].decode('utf-8'))
        return data
    except IndexError:
        return None

    #address not in any range
    # if not rngMin <= ipnum <= rngMax:
    #     return None
    
    return "found: %s" % record
