#!/bin/env python

import json
import os

import redis
from sanic import Sanic
from sanic.response import json

import ip_helpers
import redis_helpers

REDIS_HOST = os.environ.get('REDIS_HOST', 'localhost')
REDIS_PORT = os.environ.get('REDIS_PORT', 6379)
REDIS_INDEX = os.environ.get('REDIS_INDEX', 'iprange:locations')


app = Sanic()

@app.route('/<ip>')
async def test(request, ip):
    client = redis.Redis(host=REDIS_HOST, port=REDIS_PORT, db=0)
    # client = redis.Redis(unix_socket_path='/var/run/redis/redis.sock')
    result = redis_helpers.get(ip, client, REDIS_INDEX)
    return json(result)

if __name__ == '__main__':
    app.run(host='0.0.0.0', port=8000)
