#!/bin/env python3

from flask import Flask, jsonify
app = Flask(__name__)

import os
import IP2Location

database = IP2Location.IP2Location(os.path.join("/", "data", "IP2LOCATION-LITE-DB1.BIN"))

@app.route('/<ip>')
def get_location(ip):
    rec = database.get_all("213.14.95.132")
    # print(rec.country_short)
    # print(rec.country_long)
    return jsonify({
        'ip': ip,
        'countryCode':  rec.country_short.decode("utf-8") ,
        'countryName': rec.country_long.decode("utf-8") 
    })

if __name__ == '__main__':
    app.run(host='0.0.0.0', port=80)